VERSION 5.00
Begin VB.Form frmBlobResult 
   BorderStyle     =   1  'Œ()
   Caption         =   "Result"
   ClientHeight    =   5055
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3975
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5055
   ScaleWidth      =   3975
   StartUpPosition =   3  'Windows ̊l
   Begin VB.CommandButton cmdExitForm 
      Caption         =   "Exit"
      Height          =   435
      Left            =   120
      TabIndex        =   3
      Top             =   4560
      Width           =   975
   End
   Begin VB.TextBox txtResult 
      Height          =   3915
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   2
      Text            =   "frmBlobResult.frx":0000
      Top             =   540
      Width           =   3735
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "<-- back"
      Height          =   435
      Left            =   1800
      TabIndex        =   1
      Top             =   4560
      Width           =   975
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "next -->"
      Height          =   435
      Left            =   2880
      TabIndex        =   0
      Top             =   4560
      Width           =   975
   End
   Begin VB.Label lblBlobNo 
      Alignment       =   1  'E
      BorderStyle     =   1  '
      Caption         =   "Label2"
      BeginProperty Font 
         Name            =   "lr oSVbN"
         Size            =   9
         Charset         =   128
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   1320
      TabIndex        =   5
      Top             =   120
      Width           =   975
   End
   Begin VB.Label Label1 
      Alignment       =   1  'E
      Caption         =   "Blob No"
      Height          =   195
      Left            =   240
      TabIndex        =   4
      Top             =   180
      Width           =   855
   End
End
Attribute VB_Name = "frmBlobResult"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2002                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -------------------------------------------------------------------
' FVX Sample Program
' Result form
'
' Maker: K.Kotajima
'
' History : 2002/07/23 First edition
'           2004/06/30 Y.Hori a
'           result -- data -- the fault from which the circumscription rectangle lower right value had turned into an upper right value is corrected
'
' -------------------------------------------------------------------
Option Explicit


Private Const PI As Double = 3.14159265358979

'All Blob numbers
Public lngMaxBlobNo As Long

'BlobNo. (it indicates all by -1) displayed now
Private m_lngBlobNo As Long

Private Sub Form_Load()
    m_lngBlobNo = -1
    DrawAll
End Sub

'Exit
Private Sub cmdExitForm_Click()
    Unload Me
End Sub

'Next
Private Sub cmdNext_Click()
    m_lngBlobNo = m_lngBlobNo + 1
    If m_lngBlobNo > lngMaxBlobNo Then m_lngBlobNo = lngMaxBlobNo
    
    DrawOne m_lngBlobNo
End Sub

'Back
Private Sub cmdBack_Click()
    m_lngBlobNo = m_lngBlobNo - 1
    If m_lngBlobNo < -1 Then m_lngBlobNo = -1
    
    If m_lngBlobNo = -1 Then
        DrawAll
    Else
        DrawOne m_lngBlobNo
    End If
End Sub

'All Blob drawing
Private Sub DrawAll()
    Dim dblTime As Double   'Processing time
    Dim lngErr As Long      'Error number
    Dim lngCount As Long    'The number of found Blob
    
    Dim pBlobResultGroup As New FvBlobResultGroup   'Blob result
    Dim pPoint As New FvPoint                       'For a number display
    
    Dim i As Long
    
    lblBlobNo.Caption = "ALL"
    txtResult.Text = "Total:" & lngMaxBlobNo + 1

    With frmMain
        .FvxDisplayEx1.ClearOverlay
        
        'The processing range is displayed in thin blue.
        .FvxDisplayEx1.PenColor = RGB(192, 192, 255)
        .FvxDisplayEx1.DrawData 0, .m_ExeRegion
        
        .FvxDisplayEx1.PenColor = RGB(0, 0, 256)  'Character color
        .FvxDisplayEx1.FontColor = RGB(255, 0, 0) 'The color of a line
        
        'Acquisition of a result
        .FvxBlob1.GetResult 0, pBlobResultGroup
        
        'A center-of-gravity point and a circumscription rectangle are drawn.
        .FvxDisplayEx1.DrawData 0, pBlobResultGroup
        
        For i = 0 To lngMaxBlobNo
            'A Blob number is displayed in red.
            pPoint.x = pBlobResultGroup.Item(i).center_x
            pPoint.y = pBlobResultGroup.Item(i).center_y
            .FvxDisplayEx1.DrawText 0, pPoint, Str(i)
        Next
    
    End With
    
    'Memory opening
    Set pBlobResultGroup = Nothing
    Set pPoint = Nothing

End Sub

'One Blob is drawn.
Private Sub DrawOne(ByVal lngNum As Long)

    Dim pBlobResult As New FvBlobResult
    Dim dblAngle As Double 'Equivalent ellipse angle of inclination
    Dim pLine As New FvLine
    Dim pEllipse As New FvEllipse

    lblBlobNo.Caption = Str(lngNum)
    
    With frmMain
        'Elimination of an overlay screen
        .FvxDisplayEx1.ClearOverlay
        
        'The processing range is displayed in thin blue.
        .FvxDisplayEx1.PenColor = RGB(192, 192, 255)
        .FvxDisplayEx1.DrawData 0, .m_ExeRegion
    
        'Blob detailed information acquisition
        .FvxBlob1.GetResult lngNum, pBlobResult
    End With

    'The blob information on BUROBU is displayed on a text box.
    txtResult.Text = _
        "area : " & Format(pBlobResult.area, "0.00") & vbCrLf & _
        "hole_num : " & Format(pBlobResult.hole_num, "0.00") & vbCrLf & _
        "perim : " & Format(pBlobResult.perim, "0.00") & vbCrLf & _
        "ellipse_long : " & Format(pBlobResult.ellipse_long, "0.00") & vbCrLf & _
        "ellipse_short : " & Format(pBlobResult.ellipse_short, "0.00") & vbCrLf & _
        "ellipse_angle : " & Format(pBlobResult.ellipse_angle, "0.00") & vbCrLf & _
        "center : ( " & Format(pBlobResult.center_x, "0.00") & _
            " , " & Format(pBlobResult.center_y, "0.00") & " )" & vbCrLf & _
        "x_min : " & Format(pBlobResult.x_min, "0.00") & vbCrLf & _
        "x_max : " & Format(pBlobResult.x_max, "0.00") & vbCrLf & _
        "y_min : " & Format(pBlobResult.y_min, "0.00") & vbCrLf & _
        "y_max : " & Format(pBlobResult.y_max, "0.00") & vbCrLf & _
        "total_area : " & Format(pBlobResult.total_area, "0.00") & vbCrLf & _
        "bounding_upper_left : ( " & Format(pBlobResult.bounding_top_x, "0.00") & _
            " , " & Format(pBlobResult.bounding_top_y, "0.00") & " )" & vbCrLf & _
        "bounding_upper_right : ( " & Format(pBlobResult.bounding_right_x, "0.00") & _
            " , " & Format(pBlobResult.bounding_right_y, "0.00") & " )" & vbCrLf & _
        "bounding_ lower_left : ( " & Format(pBlobResult.bounding_left_x, "0.00") & _
            " , " & Format(pBlobResult.bounding_left_y, "0.00") & " )" & vbCrLf & _
        "bounding_lower_right : ( " & Format(pBlobResult.bounding_bottom_x, "0.00") & _
            " , " & Format(pBlobResult.bounding_bottom_y, "0.00") & " )" & vbCrLf

    'Color of a line = blue
    frmMain.FvxDisplayEx1.PenColor = RGB(0, 0, 255)

    'Equivalent ellipse
    pEllipse.angle = pBlobResult.ellipse_angle
    pEllipse.axis_x = pBlobResult.ellipse_long
    pEllipse.axis_y = pBlobResult.ellipse_short
    pEllipse.x = pBlobResult.center_x
    pEllipse.y = pBlobResult.center_y
    frmMain.FvxDisplayEx1.DrawData 0, pEllipse

    'It passes along the center of gravity and they are the long axis of an equivalent ellipse, and the straight line of the direction of a short axis.
    'Center-of-gravity point:(x1, y1)    Equivalent ellipse angle of inclination:
    ' - xsin + ycos + ( x1sin - y1cos ) = 0
    dblAngle = pBlobResult.ellipse_angle * PI / 180
    pLine.a = -Sin(dblAngle)
    pLine.b = Cos(dblAngle)
    pLine.c = (pBlobResult.center_x * Sin(dblAngle)) - (pBlobResult.center_y * Cos(dblAngle))
    frmMain.FvxDisplayEx1.DrawData 0, pLine

    dblAngle = (pBlobResult.ellipse_angle + 90) * PI / 180
    pLine.a = -Sin(dblAngle)
    pLine.b = Cos(dblAngle)
    pLine.c = (pBlobResult.center_x * Sin(dblAngle)) - (pBlobResult.center_y * Cos(dblAngle))
    frmMain.FvxDisplayEx1.DrawData 0, pLine

    'Drawing of a center-of-gravity point and a circumscription rectang
    frmMain.FvxDisplayEx1.DrawData 0, pBlobResult

    'Memory opening
    Set pBlobResult = Nothing
    Set pEllipse = Nothing
    Set pLine = Nothing
    
End Sub

